@echo off

:: Check if exactly one argument is provided
if "%~1"=="" goto usage
set "input_file=%~1"
set "output_ext=%input_file:*.=%"
set "output_file=%input_file:*.=% (4-3 Patched).%output_ext%"

if exist "%output_file%" (
    echo Error: Output file '%output_file%' already exists. Please remove it before running this script or choose a different file.
    exit /b 1
)

set "temp_dir=%temp%\%random%"
md "%temp_dir%"

set "patch_data=00D0C0DE00D0C0DEC0000000000000073D40CD803D203000614A06A061290002912A00007C0006AC394A0008812A00007C0004AC61290002912A00007C0006AC4E80002000000000F000000000000000"
set "patch_file=%temp_dir%\patch.bin"
echo %patch_data% | xxd -r -p > "%patch_file%"

wit extract "%input_file%" "%temp_dir%\wii"
wstrt patch --add-section "%patch_file%" "%temp_dir%\wii\DATA\sys\main.dol"
del "%patch_file%"
wit copy "%temp_dir%\wii" "%output_file%"
rd /s /q "%temp_dir%"

echo Processing completed. Output file: '%output_file%'
goto end

:usage
echo Usage: %0 ^<input-file^>
exit /b 1

:end
