#!/bin/sh

if [ "$#" -ne 1 ]; then
    echo "Usage: $0 <input-file>"
    exit 1
fi

input_file="$1"
output_file="${input_file%.*} (4:3 Patched).${input_file##*.}"

if [ -e "$output_file" ]; then
    echo "Error: Output file '$output_file' already exists. Please remove it before running this script or choose a different file."
    exit 1
fi

temp_dir=$(mktemp -d) || exit 1
patch_data="00D0C0DE00D0C0DEC0000000000000073D40CD803D203000614A06A061290002912A00007C0006AC394A0008812A00007C0004AC61290002912A00007C0006AC4E80002000000000F000000000000000"
patch_file="$temp_dir/patch.bin"
printf "%s" "$patch_data" | xxd -r -p > "$patch_file"

wit extract "$input_file" "$temp_dir/wii"
wstrt patch --add-section "$patch_file" "$temp_dir/wii/DATA/sys/main.dol"
rm "$patch_file"
wit copy "$temp_dir/wii" "$output_file"
rm -rf "$temp_dir"

echo "Processing completed. Output file: $output_file"
